//
// Mining module for TETDM
// DataMining.java Version 1.00
// This is one of the sample modules.
// You should read the README file.
//

package module.MiningModules.DataMining;

import source.*;
import source.TextData.*;
//import source.Utility.*;
import java.io.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

import org.rosuda.JRI.REXP;
import org.rosuda.JRI.Rengine;



public class DataMining extends MiningModule  implements ActionListener, ChangeListener
{    
    JComboBox itemCombo;
    JSlider valueSlider;
    JLabel valueLabel;
    JComboBox ijouCombo;
    
    JPanel upperPanel, lowerPanel;
    
    JComboBox osusumeCombo;
    JComboBox startCombo;
    
//    JTextField textfield31;
//    JTextField textfield32;
    

    
    int displaycount = 0;
    
    String csvPath;
    String csvName = "test3kasituki.csv";
//    String csvName = "test3.csv";

    final int MAXDATA = 1000;
    String data[][];
    String header[];
    int dataNumber;
    
    double rowData[][];
    double dataRangeMin[];
    double dataRangeMax[];
    
    final int maxFrequency = 100;
    int frequencyData[][];
    

    String formula;
    String[] DataminingTableColName;
    String[] DataminingTableRowName;
    double doubleDataArray[][];

    String firstColumn[];
    double valueData[][];

    public DataMining()
    {
        setModuleID(50000);                        // Set your module ID after you have got it
        setCategoryID(7);
        pairingVisualizationID = new int[]{0};
        defaultSetPanelModuleID = new int[]{50000,50010};
        defaultSetPanelVisualizationID = new int[]{24,24};
        
        forcedDisplayOperationPanel = true;
    }
    
    public void initializePanel()
    {
        if(text.control.initializeR == true)
        {
            Rengine re = new Rengine(new String[]{"--no-save"},false,null);
            re.end();
            
            text.control.initializeR = false;
        }
        
        upperPanel = new JPanel();
        upperPanel.setLayout(new GridLayout(1,4));
        upperPanel.setBackground(new Color(255, 255, 0));
        upperPanel.setOpaque(true);
        
        lowerPanel = new JPanel();
        lowerPanel.setLayout(new GridLayout(1,2));
        lowerPanel.setBackground(new Color(255, 192, 203));
        lowerPanel.setOpaque(true);
        
        operationPanel.setLayout(new GridLayout(2,1));
//        operationPanel.setBackground(new Color(102, 205, 170));
        operationPanel.setOpaque(true);
        operationPanel.add(upperPanel);
        operationPanel.add(lowerPanel);
                                 
        inJapanese = fileReadArray();

        /*
        textfield31 = new JTextField(10);
        textfield31.addActionListener(this);
        operationPanel.add(textfield31);
        
        textfield32 = new JTextField(10);
        textfield32.addActionListener(this);
        operationPanel.add(textfield32);
        */
        
        String[] koumoku = {"Item"};
        if(isMenuInJapanese())
                koumoku[0] = inJapanese[57];

        itemCombo = new JComboBox(koumoku);
        itemCombo.addActionListener(this);
        upperPanel.add(itemCombo);


        valueSlider = new JSlider(0, 100, 50);
        valueSlider.addChangeListener(this);
        upperPanel.add(valueSlider);

        
        valueLabel = new JLabel();
        valueLabel.setText("0");
        upperPanel.add(valueLabel);
        
        String[] ijou = {"+","-"};
        if(isMenuInJapanese())
        {
            ijou[0] = inJapanese[54];
            ijou[1] = inJapanese[55];
        }
        
        
        ijouCombo = new JComboBox(ijou);
        ijouCombo.addActionListener(this);
        upperPanel.add(ijouCombo);
        
        
        
        
        String[] fc = {"Statistic","Basic","Rel. Matrix","Ass. Rules"};
        if(isMenuInJapanese())
        {
            fc[0] = inJapanese[12];
            fc[1] = inJapanese[27];
            fc[2] = inJapanese[28];
            fc[3] = inJapanese[29];
        }
        
        
        startCombo = new JComboBox(fc);
        startCombo.addActionListener(this);
        lowerPanel.add(startCombo);
        
        String[] osusume = {"Recommendation","Max Values","Min Values","Excp. Max Min","Min Freq.","Max Freq"};
        if(isMenuInJapanese())
        {
            osusume[0] = inJapanese[41];
            osusume[1] = inJapanese[42];
            osusume[2] = inJapanese[43];
            osusume[3] = inJapanese[44];
            osusume[4] = inJapanese[45];
            osusume[5] = inJapanese[46];
        }
        
        osusumeCombo = new JComboBox(osusume);
        osusumeCombo.addActionListener(this);
        lowerPanel.add(osusumeCombo);
        
    }
    
    public void initializeData()
    {
        Rengine rf = Rengine.getMainEngine();

        csvPath = text.absolutePath + File.separator + "text";
        
        csvName = new File(text.sourceFilename).getName();
        int point = csvName.lastIndexOf(".");
        if (point != -1)
            csvName = csvName.substring(0, point) + ".csv";
        else
            csvName = csvName.substring(0, csvName.length()-1) + ".csv";


        if(displaycount == 0)
        {
            rf.assign("rcsvpathobj",csvPath);
            rf.eval("setwd(rcsvpathobj)");
            
            rf.assign("csvnameobj",csvName);
            rf.eval("csv <- read.csv2(csvnameobj,header = TRUE, sep = ',', fileEncoding=\"sjis\")");
            
            displaycount = 1;
        }

        try{
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(csvPath+File.separator+csvName), "JISAutoDetect"));
 //         FileReader fr = new FileReader(csvPath+File.separator+csvName);
   //        BufferedReader br = new BufferedReader(fr);
            
            String line = br.readLine();
            header = line.split(",");
            
            data = new String[MAXDATA][];
            for(dataNumber=0; (line = br.readLine()) != null && dataNumber<MAXDATA; dataNumber++)
                data[dataNumber] = line.split(",");
            
            br.close();
        }
        catch (IOException ex){
            System.out.println("File "+csvPath+File.separator+csvName+" not found");
        }
        
        rowData = new double[header.length-1][dataNumber];
        dataRangeMin = new double[header.length-1];
        dataRangeMax = new double[header.length-1];
        
        for(int i=0;i<dataNumber;i++)
            for(int j=1;j<header.length;j++)
                rowData[j-1][i] = Integer.parseInt(data[i][j]);
        
        calculateMaxMin();
        calculateFrequency();
        
        /////////////////////
        if(text.textID != 0)
        {
            boolean focusSegments[] = text.control.text.focus.getFocusSegments();
            dataNumber=0;
            for(int i=0;i<text.control.text.segmentNumber;i++)
                if(focusSegments[i])
                    dataNumber++;
        }
            
        firstColumn= new String[dataNumber];
        valueData = new double[header.length-1][dataNumber];
        
        if(text.textID != 0)
        {
            boolean focusSegments[] = text.control.text.focus.getFocusSegments();
            for(int i=0,k=0;i<text.control.text.segmentNumber;i++)
                if(focusSegments[i])
                {
                    firstColumn[k] = data[i][0];

                    for(int j=0;j<header.length-1;j++)
                        valueData[j][k] = Double.parseDouble(data[i][j+1]);
                    k++;
                }
        }
        else
        {
            for(int i=0;i<dataNumber; i++)
                firstColumn[i] = data[i][0];
            
            for(int j=0;j<header.length-1;j++)
                for(int i=0;i<dataNumber;i++)
                    valueData[j][i] = Double.parseDouble(data[i][j+1]);
        }
        
        for(int i=1;i<header.length;i++)
            itemCombo.addItem(header[i]);
        

        /////////////////////
        
        
        rf.end();
    }
    
    

    
    public void miningOperations(int optionNumber)
    {
        switch(optionNumber)
        {
            case 0:
                setDataStringArray(0,header);
                setDataStringArray(1,firstColumn);
                setDataDoubleArray2(0,valueData);
                break;
                
            /*
            case 1:
                initializeData();
                break;
  

                
            case 1202:
                createSegmentPartialData(1);
                break;
             */
   /*
            case 1100:
                //zyouken itti focussegments henkou
                
                String orText = textfield31.getText();
                int orX = Integer.parseInt(orText);
                int orTarget;

                int CsvRowNum;
                Rengine rf = Rengine.getMainEngine();
                formula = "nrow(csv)";
                CsvRowNum = (int)answerRdouble(rf.eval(formula).toString());

                int k;
                int j;
                for(int i =1;i <= CsvRowNum;i++)
                {
                    formula = "csv[" + String.valueOf(2) +","+ String.valueOf(2) +"]";//csv[0,]ha sonnzaisinai tame (i)+1 suru
                    j = (int)answerRdouble(rf.eval(formula).toString());

                    formula = "csv[" + String.valueOf(i) +",1]";//csv[0,]ha sonnzaisinai tame (i)+1 suru
                    k = (int)answerRdouble(rf.eval(formula).toString());
 
//                    formula = "csv[" + String.valueOf(i) +","+ String.valueOf(columnP+1) +"]";
  //                  orTarget = (int)answerRdouble(rf.eval(formula).toString());
  
//                    if(orTarget == orX)
  //                      text.focus.focusSegments[k-1] =true;
                }
                rf.end();
                break;
                
            case 1200:
                String andText = textfield32.getText();
                int andX = Integer.parseInt(andText);
                int andTarget;

                int CsvRowNumtwo;
                Rengine rg = Rengine.getMainEngine();
                formula = "nrow(csv)";
                CsvRowNumtwo = (int)answerRdouble(rg.eval(formula).toString());

                int orinum;
                
                for(int i =1;i <= CsvRowNumtwo;i++)
                {
                    formula = "csv[" + String.valueOf(i) +",1]";//csv[0,]ha sonnzaisinai tame (i)+1 suru
                    orinum = (int)answerRdouble(rg.eval(formula).toString());

 //                   formula = "csv[" + String.valueOf(i) +","+ String.valueOf(columnP+1) +"]";
   //                 andTarget = (int)answerRdouble(rg.eval(formula).toString());
                    
//                    if(text.focus.focusSegments[orinum-1] == true)
  //                      if(andTarget != andX)
    //                        text.focus.focusSegments[orinum-1] =false;
                }
                rg.end();
                break;
                */
                
        }
    }
    


    

    public double answerRdouble(String answerBeforeString)
    {
        double answer;
        String answerAfterString;
        
        int startnum = answerBeforeString.indexOf("(");
        int endnum = answerBeforeString.indexOf(")");
        
        answerAfterString  = answerBeforeString.substring(startnum+1,endnum);
        
        if(answerAfterString.equals("NaN"))
            answer = 0;
        else
            answer = Double.parseDouble(answerAfterString);

        return answer;
    }

    public static int answerRint(String answerBeforeString)
    {
        int answer;
        String answerAfterString;
        
        int startnum = answerBeforeString.indexOf("(");
        int endnum = answerBeforeString.indexOf(")");
        
        answerAfterString  = answerBeforeString.substring(startnum+1,endnum);
        answer = Integer.parseInt(answerAfterString);
        
        return answer;
    }

    void SelectCalcDisplay()
    {
        Rengine rf = Rengine.getMainEngine();
    
//        int CsvColNum = header.length-1;
        int CsvColNum = (int)answerRdouble(rf.eval("ncol(csv)").toString());
//        int CsvRowNum = (int)answerRdouble(rf.eval("nrow(csv)").toString());

        System.out.println("SELECTED ITEM = "+startCombo.getSelectedItem());
        System.out.println("CsvColNum = "+CsvColNum);
        
        if(startCombo.getSelectedIndex() == 1)/*kihontoukeiryou*//////////////////////////************
        {
            doubleDataArray = new double[CsvColNum-1][7];//
            DataminingTableColName = new String[CsvColNum];//
            DataminingTableRowName = new String[7];
            String englishRowName[] = {"Ave","Min","Max","Median","Var","Std","CV"};
            

            
            DataminingTableColName[0] = "#";
            for(int i=1;i<CsvColNum;i++)
                DataminingTableColName[i] = header[i];

            if(isMenuInJapanese())
            {
                DataminingTableRowName[0] =  inJapanese[13];//heikin
                DataminingTableRowName[1] = inJapanese[14];
                DataminingTableRowName[2] = inJapanese[15];
                DataminingTableRowName[3] = inJapanese[16];
                DataminingTableRowName[4] = inJapanese[17];//huhenbunsan
                DataminingTableRowName[5] = inJapanese[32];//hyouzyunhensa
                DataminingTableRowName[6] = inJapanese[34];//hendoukeisuu
            }
            else
                for(int i=0;i<7;i++)
                    DataminingTableRowName[i] =  englishRowName[i];

            
            
            for(int i=2;i<=CsvColNum;i++)      //begin with 1 in R functions
            {
                formula = "mean" + "(csv[,"+ String.valueOf(i) +"])";
                doubleDataArray[i-2][0] = answerRdouble(rf.eval(formula).toString());
                
                formula = "min" + "(csv[,"+ String.valueOf(i) +"])";
                doubleDataArray[i-2][1] = answerRdouble(rf.eval(formula).toString());
                
                formula = "max" + "(csv[,"+ String.valueOf(i) +"])";
                doubleDataArray[i-2][2] = answerRdouble(rf.eval(formula).toString());
                
                formula = "median" + "(csv[,"+ String.valueOf(i) +"])";
                doubleDataArray[i-2][3] = answerRdouble(rf.eval(formula).toString());
                
                formula = "var" + "(csv[,"+ String.valueOf(i) +"])";
                doubleDataArray[i-2][4] = answerRdouble(rf.eval(formula).toString());
                
                formula = "sd" + "(csv[,"+ String.valueOf(i) +"])";
                doubleDataArray[i-2][5] = answerRdouble(rf.eval(formula).toString());
                
                formula = "sd" + "(csv[,"+ String.valueOf(i) +"])" + " / " + "mean" + "(csv[,"+ String.valueOf(i) +"])";
                doubleDataArray[i-2][6] = answerRdouble(rf.eval(formula).toString());
            }
        }
        

        
        
        if(startCombo.getSelectedIndex() == 2)/*soukangyouretu*//////////////////////////************
        {
            doubleDataArray = new double[CsvColNum-1][CsvColNum-1];//6*6
            DataminingTableColName = new String[CsvColNum];//7
            DataminingTableRowName = new String[CsvColNum-1];//6
            
            DataminingTableColName[0] = "#";
            
            for(int i=0;i<CsvColNum-1;i++)
            {
                DataminingTableColName[i+1] = header[i+1];
                DataminingTableRowName[i] = header[i+1];
            }

            for(int i=2;i<=CsvColNum;i++)//begin with 1 in R functions
                for(int j=2;j<=CsvColNum;j++)//begin with 1 in R functions
                {
                    formula = "cor" + "(" + "csv[,"+ String.valueOf(j) + "]" + ",csv[," + String.valueOf(i) +"])";
                    doubleDataArray[i-2][j-2] = answerRdouble(rf.eval(formula).toString());
                }
            /**/
            for(int i=0;i<CsvColNum;i++)
                System.out.println(DataminingTableColName[i]);
            
            for(int i=0;i<CsvColNum-1;i++)
                System.out.println(DataminingTableRowName[i]);

            for(int i=0;i<CsvColNum-1;i++)
            {
                for(int j=0;j<CsvColNum-1;j++)
                    System.out.print(doubleDataArray[i][j] + " ");
                System.out.println("");
            }/**/
        }
        
        ///////////////////////////////////
        if(startCombo.getSelectedIndex() == 3)/*association*//////////////////////////************
        {
            rf.eval("library(arules)");

            rf.eval("csvf <- csv");
            
            for(int i=1;i<=CsvColNum;i++)//begin with 1 in R functions// Do not work unless i=1 to CsvColNum
            {
                formula = "csvf[," + String.valueOf(i) + "] <- factor(csv[," + String.valueOf(i) + "])";
                rf.eval(formula);
            }
            
            for(int i=1;i<=CsvColNum;i++)//begin with 1 in R functions// Do not work unless i=1 to CsvColNum
            {
                formula = "class(csvf[,"+ String.valueOf(i) +"])";
                rf.eval(formula);
            }
            
            rf.assign("tranobj","transactions");

            rf.eval("tranobj");
            rf.eval("csvf" + " <- " + "as(csvf,"+ "tranobj" + ")");
            rf.eval("csvf");
            rf.eval("csvf<-apriori(csvf)");

            String AprioriResult = rf.eval("inspect(head(sort(csvf, by=\"support\"),n=20))").toString();
            
            System.out.println(AprioriResult);
            
            /*LHS YOUSO 1111111111111111111111111111111111111111111111111111111111111111111111111111*/
            String LhsLevels;
            int LhsLevelsStart;
            int LhsLevelsEnd;
            
            LhsLevelsStart = AprioriResult.indexOf("levels");
            LhsLevelsEnd = AprioriResult.indexOf("ids");

            LhsLevels = AprioriResult.substring(LhsLevelsStart,LhsLevelsEnd);

            String LhsLevelsyouso;
            int kakko1Start;
            int kakko1End;
            
            
            int kakko1StartNext = 0;
            int kakko1EndNext = 0;
            
            
            int YousoCount1 = 0;
            String kakko1 = "{";
            
            int index1 =0;
            
            for(int s =0;s < LhsLevels.length();s++)
            {
                if(LhsLevels.indexOf(kakko1,s) == -1)
                    break;

                index1 = LhsLevels.indexOf(kakko1,s);
                s = index1 + kakko1.length();
                YousoCount1++;
            }
            
            
            String LhsLevelsHairetu[] = new String[YousoCount1];

            
            
            for(int i= 0;i<YousoCount1;i++)
            {
                kakko1Start = LhsLevels.indexOf("\"{",kakko1StartNext) +2;
                kakko1End = LhsLevels.indexOf("}\"",kakko1EndNext);

                LhsLevelsyouso = LhsLevels.substring(kakko1Start,kakko1End);
                LhsLevelsHairetu[i] = LhsLevelsyouso;

                kakko1StartNext = kakko1Start + 1;
                kakko1EndNext = kakko1End + 1;
                
//                System.out.println(LhsLevelsHairetu[i]+" ");
            }



            /*LhsLevels YOUSO 1111111111111111111111111111111111111111111111111111111111111111111*/
            
            
            /*LHS Number 22222222222222222222222222222222222222222222222222222222222222222222*/
            String LhsNumber;
            int LhsNumberStart;
            int LhsNumberEnd;

            LhsNumberStart = AprioriResult.indexOf("ids",0) + 5;
            LhsNumberEnd = AprioriResult.indexOf(")}],");

            LhsNumber = AprioriResult.substring(LhsNumberStart,LhsNumberEnd);

            String LhsNumberyouso;
            int Comma1Start;
            int Comma1End;
            
            
            int Comma1StartNext = 0;
            int Comma1EndNext = 0;
            
            
            int NumberCount1 = 1;
            String Comma1 = ",";
            
            int indexC1 =0;
            
            for(int s =0;s < LhsNumber.length();s++)
            {
                if(LhsNumber.indexOf(Comma1,s) == -1)
                    break;
                
                indexC1 = LhsNumber.indexOf(Comma1,s);
                s = indexC1 + Comma1.length();
                NumberCount1++;
            }
            
            int LhsNumberHairetu[] = new int[NumberCount1];

            LhsNumber = "," + LhsNumber +",";

            for(int i= 0;i<NumberCount1;i++)
            {
                Comma1Start = LhsNumber.indexOf(",",Comma1StartNext) +1;
                Comma1End = LhsNumber.indexOf(",",Comma1Start + 1);

                LhsNumberyouso = LhsNumber.substring(Comma1Start,Comma1End);

                LhsNumberHairetu[i] = Integer.parseInt(LhsNumberyouso);

                Comma1StartNext = Comma1Start + 1;
                Comma1EndNext = Comma1End + 1;
            }

            /*LHS Number 22222222222222222222222222222222222222222222222222222222222222222222*/
            
            /* => */
            int TunagiStart;
            int TunagiEnd;
            
            TunagiStart = AprioriResult.indexOf("levels",LhsLevelsStart +2) +2;
            TunagiEnd = AprioriResult.indexOf("ids",LhsLevelsEnd +2) +2;
            /* => */
            
            
            /*RHS Youso 33333333333333333333333333333333333333333333333333333333333333333333*/
            
            String RhsLevels;
            int RhsLevelsStart;
            int RhsLevelsEnd;
            
            
            RhsLevelsStart = AprioriResult.indexOf("levels",TunagiStart);
            RhsLevelsEnd = AprioriResult.indexOf("ids",TunagiEnd);

            RhsLevels = AprioriResult.substring(RhsLevelsStart,RhsLevelsEnd);

            
            
            String RhsLevelsyouso;
            int kakko2Start;
            int kakko2End;
            
            
            int kakko2StartNext = 0;
            int kakko2EndNext = 0;
            
            
            int YousoCount2 = 0;
            String kakko2 = "{";
            
            int index2 =0;
            
            for(int s =0;s < RhsLevels.length();s++)
            {
                if(RhsLevels.indexOf(kakko2,s) == -1)
                    break;

                index2 = RhsLevels.indexOf(kakko2,s);
                s = index2 + kakko2.length();
                YousoCount2++;
            }
            
            
            String RhsLevelsHairetu[] = new String[YousoCount2];
            
            
            for(int i= 0;i<YousoCount2;i++)
            {
                kakko2Start = RhsLevels.indexOf("\"{",kakko2StartNext) +2;
                kakko2End = RhsLevels.indexOf("}\"",kakko2EndNext);

                RhsLevelsyouso = RhsLevels.substring(kakko2Start,kakko2End);

                RhsLevelsHairetu[i] = RhsLevelsyouso;
                
                kakko2StartNext = kakko2Start + 1;
                kakko2EndNext = kakko2End + 1;
            }
            

            
            /*RHS Youso 33333333333333333333333333333333333333333333333333333333333333333333*/
            
            
            /*RHS Number 44444444444444444444444444444444444444444444444444444444444444444444*/
            
            
            
            
            String RhsNumber;
            int RhsNumberStart;
            int RhsNumberEnd;
            
            
            RhsNumberStart = AprioriResult.indexOf("ids",RhsLevelsStart+2) + 5;
            RhsNumberEnd = AprioriResult.indexOf(")}],",RhsLevelsEnd+2);

            RhsNumber = AprioriResult.substring(RhsNumberStart,RhsNumberEnd);

            String RhsNumberyouso;
            int Comma2Start;
            int Comma2End;
            
            
            int Comma2StartNext = 0;
            int Comma2EndNext = 0;
            
            
            int NumberCount2 = 1;
            String Comma2 = ",";
            
            int indexC2 =0;
            
            for(int s =0;s < RhsNumber.length();s++)
            {
                if(RhsNumber.indexOf(Comma2,s) == -1)
                    break;
                indexC2 = RhsNumber.indexOf(Comma2,s);
                s = indexC2 + Comma2.length();
                NumberCount2++;
            }
            
            int RhsNumberHairetu[] = new int[NumberCount2];

            RhsNumber = "," + RhsNumber +",";

            for(int i= 0;i<NumberCount2;i++)
            {
                Comma2Start = RhsNumber.indexOf(",",Comma2StartNext) +1;
                Comma2End = RhsNumber.indexOf(",",Comma2Start + 1);

                RhsNumberyouso = RhsNumber.substring(Comma2Start,Comma2End);
                
                RhsNumberHairetu[i] = Integer.parseInt(RhsNumberyouso);

                Comma2StartNext = Comma2Start + 1;
                Comma2EndNext = Comma2End + 1;
            }
            

            
            //RHS Number 44444444444444444444444444444444444444444444444444444444444444444444*/
            
            //support
            int SupportStart;
            int SupportEnd;
            String SupportStr;
            
            SupportStart = AprioriResult.indexOf("REAL* (") + 7;
            SupportEnd = AprioriResult.indexOf(")]",SupportStart+2);

            SupportStr = AprioriResult.substring(SupportStart,SupportEnd);

            
            String SupportStryouso;
            int Comma3Start;
            int Comma3End;
            
            
            int Comma3StartNext = 0;
            int Comma3EndNext = 0;
            
            
            int NumberCount3 = 1;
            String Comma3 = ",";
            
            int indexC3 =0;
            
            for(int s =0;s < SupportStr.length();s++) {
                
                if(SupportStr.indexOf(Comma3,s) == -1)
                {
                    break;
                }
                indexC3 = SupportStr.indexOf(Comma3,s);
                s = indexC3 + Comma3.length();
                NumberCount3++;
            }
            
            double SupportHairetu[] = new double[NumberCount3];

            SupportStr = "," + SupportStr +",";
            for(int i= 0;i<NumberCount3;i++)
            {
                Comma3Start = SupportStr.indexOf(",",Comma3StartNext) +1;
                Comma3End = SupportStr.indexOf(",",Comma3Start + 1);

                SupportStryouso = SupportStr.substring(Comma3Start,Comma3End);
                
                SupportHairetu[i] = Double.parseDouble(SupportStryouso);
                
                Comma3StartNext = Comma3Start + 1;
                Comma3EndNext = Comma3End + 1;
            }

            // confidence

            
            int ConfidenceStart = AprioriResult.indexOf("REAL* (", SupportEnd)+7;
            int ConfidenceEnd = AprioriResult.indexOf(")]",ConfidenceStart+2);
            
            SupportStr = AprioriResult.substring(ConfidenceStart,ConfidenceEnd);

            Comma3StartNext = 0;
            Comma3EndNext = 0;
            
            NumberCount3 = 1;
            Comma3 = ",";
            
            indexC3 =0;
            
            for(int s =0;s < SupportStr.length();s++) {
                
                if(SupportStr.indexOf(Comma3,s) == -1)
                {
                    break;
                }
                indexC3 = SupportStr.indexOf(Comma3,s);
                s = indexC3 + Comma3.length();
                NumberCount3++;
            }
            
            double ConfidenceHairetu[] = new double[NumberCount3];
            
            SupportStr = "," + SupportStr +",";
            for(int i= 0;i<NumberCount3;i++)
            {
                Comma3Start = SupportStr.indexOf(",",Comma3StartNext) +1;
                Comma3End = SupportStr.indexOf(",",Comma3Start + 1);
                
                SupportStryouso = SupportStr.substring(Comma3Start,Comma3End);
                
                ConfidenceHairetu[i] = Double.parseDouble(SupportStryouso);
                
                Comma3StartNext = Comma3Start + 1;
                Comma3EndNext = Comma3End + 1;
            }
            
            // lift
            
            int LiftStart = AprioriResult.indexOf("REAL* (", ConfidenceEnd)+7;
            int LiftEnd = AprioriResult.indexOf(")]",LiftStart+2);
            
            SupportStr = AprioriResult.substring(LiftStart,LiftEnd);
            
            Comma3StartNext = 0;
            Comma3EndNext = 0;
            
            NumberCount3 = 1;
            Comma3 = ",";
            
            indexC3 =0;
            
            for(int s =0;s < SupportStr.length();s++) {
                
                if(SupportStr.indexOf(Comma3,s) == -1)
                {
                    break;
                }
                indexC3 = SupportStr.indexOf(Comma3,s);
                s = indexC3 + Comma3.length();
                NumberCount3++;
            }
            
            double LiftHairetu[] = new double[NumberCount3];
            
            SupportStr = "," + SupportStr +",";
            for(int i= 0;i<NumberCount3;i++)
            {
                Comma3Start = SupportStr.indexOf(",",Comma3StartNext) +1;
                Comma3End = SupportStr.indexOf(",",Comma3Start + 1);
                
                SupportStryouso = SupportStr.substring(Comma3Start,Comma3End);
                
                LiftHairetu[i] = Double.parseDouble(SupportStryouso);
                
                Comma3StartNext = Comma3Start + 1;
                Comma3EndNext = Comma3End + 1;
            }
            
            /////

            
            DataminingTableColName = new String[4];
            
            if(isMenuInJapanese())
            {
                DataminingTableColName[0] = inJapanese[204];/*rules*/
                DataminingTableColName[1] = inJapanese[201];/*support*/
                DataminingTableColName[2] = inJapanese[202];/*confidence*/
                DataminingTableColName[3] = inJapanese[203];/*lift*/
            }
            else
            {
                DataminingTableColName[0] = "Rules";/*rules*/
                DataminingTableColName[1] = "Support";/*support*/
                DataminingTableColName[2] = "Confidence";/*confidence*/
                DataminingTableColName[3] = "Lift";/*lift*/
            }
            
            DataminingTableRowName = new String[NumberCount1];
            doubleDataArray = new double[3][NumberCount1];

            for(int i=0; i<NumberCount1; i++)
            {
                DataminingTableRowName[i] = String.valueOf(LhsLevelsHairetu[LhsNumberHairetu[i]]) + " -> " + String.valueOf(RhsLevelsHairetu[RhsNumberHairetu[i]]);

                doubleDataArray[0][i] = SupportHairetu[i];
                doubleDataArray[1][i] = ConfidenceHairetu[i];
                doubleDataArray[2][i] = LiftHairetu[i];
            }

        }
        /////////////////////////////////////////////////////////////////////

        rf.end();
    }
    /////////////////
    /*
    public void testFocus()
    {
        boolean data[] = new boolean[text.segmentNumber];
        
        for(int i=0;i<text.segmentNumber;i++)
            data[i] = true;
        
        data[0] = false;
        
        setFocusSegments(data);
    }
    
    public void setFocusSegments(boolean data[])
    {
        for(int i=0;i<text.segmentNumber;i++)
            text.focus.focusSegments[i] = data[i];
        
        copyToOriginalFocusData();
    }
    */
    
    /*
    public void copyToOriginalFocusData()
    {
        if(text.textID == 0)
            return;
        
        TextData originalTextData = text.control.text;
        boolean originalFocusSegments[] = new boolean[originalTextData.segmentNumber];
        boolean focusSegments[] = text.focus.getFocusSegments();
        
        for(int i=0;i<originalTextData.segmentNumber;i++)
            originalFocusSegments[i] = false;
        
        for(int i=0;i<text.segmentNumber;i++)
            if(focusSegments[i])
                originalFocusSegments[text.originalSegmentNumbers[i]] = true;
        
        originalTextData.focus.setFocusSegments(originalFocusSegments);
    }
     */
    /////////////////
    
    //Action listener
    public void actionPerformed(ActionEvent e)
    {
        writeButtonLog(e);
        
        if(e.getSource() == osusumeCombo)
            easyHighLight();

        
        if(e.getSource() == ijouCombo)
            createHighLight();
        
        if(e.getSource() == itemCombo)
            createHighLight();
        
    /////////////////

        
        if(startCombo.getSelectedIndex() == 1 || startCombo.getSelectedIndex() == 2 || startCombo.getSelectedIndex() == 3)//Soukan
        {
            SelectCalcDisplay();
            
            setDataStringArray(9,DataminingTableColName);
            setDataStringArray(10,DataminingTableRowName);
            setDataDoubleArray2(8,doubleDataArray);
            
            int caseID=234;
            if(startCombo.getSelectedIndex() == 3)
                caseID = 233;
            
            executeOtherModule(50010, caseID);
        }
    }
    
    double findMax(double a[])
    {
        double max = a[0];
        for(int i=1;i<a.length;i++)
            if(a[i] > max)
                max = a[i];
        return max;
    }
    
    double findMin(double a[])
    {
        double min = a[0];
        for(int i=1;i<a.length;i++)
            if(a[i] < min)
                min = a[i];
        return min;
    }
    
    int findMinID(int a[])
    {
        int min = dataNumber;
        int minID = -1;
        
        for(int i=0;i<a.length;i++)
            if(a[i] < min && a[i] != 0)
            {
                min = a[i];
                minID = i;
            }
        return minID;
    }
    
    int findMaxID(int a[])
    {
        int max = a[0];
        int maxID = 0;
        
        for(int i=1;i<a.length;i++)
            if(a[i] > max)
            {
                max = a[i];
                maxID = i;
            }
        return maxID;
    }
    
    void calculateMaxMin()
    {
        for(int i=0;i<header.length-1;i++)
        {
            dataRangeMax[i] = findMax(rowData[i]);
            dataRangeMin[i] = findMin(rowData[i]);
        }
    }
    
    void calculateFrequency()
    {
        frequencyData = new int[header.length-1][maxFrequency+1];
        
        for(int i=0;i<header.length-1;i++)
            for(int j=0;j<maxFrequency;j++)
                frequencyData[i][j] = 0;
        
        for(int i=0;i<header.length-1;i++)
            for(int j=0;j<dataNumber;j++)
            {
                int singleData = (int)rowData[i][j];
                if(singleData < 0 || singleData > maxFrequency)
                    continue;
                
                frequencyData[i][singleData]++;
            }
    }
    
    public void createHighLight()
    {
        int columnNumber = itemCombo.getSelectedIndex() - 1;
        int ijou = ijouCombo.getSelectedIndex();
        
        if(columnNumber == -1)
            return;
        
        double max = dataRangeMax[columnNumber];
        double min = dataRangeMin[columnNumber];
        int border = (int)(min + (max-min)*valueSlider.getValue()/100.0);
        
        valueLabel.setText(" "+border);
        
        int highlightColumnList[] = new int[1];
        int highlightColumnlowerBorder[] = new int[1];
        int highlightColumnupperBorder[] = new int[1];
        
        highlightColumnList[0] = columnNumber+1;
        if(ijou == 0)
        {
            highlightColumnlowerBorder[0] = (int)border;
            highlightColumnupperBorder[0] = (int)max+1;
        }
        else
        {
            highlightColumnlowerBorder[0] = (int)min-1;
            highlightColumnupperBorder[0] = (int)border;
        }
        
        setDataIntegerArray(0,highlightColumnList);
        setDataIntegerArray(1,highlightColumnlowerBorder);
        setDataIntegerArray(2,highlightColumnupperBorder);
        
        displayOperations(25);
    }
    
    public void stateChanged(ChangeEvent e)
    {
        createHighLight();
    }
    
    public void easyHighLight()
    {
        int optionNumber = osusumeCombo.getSelectedIndex() - 1;
        
        if(optionNumber == -1)
            return;
        
        int highlightColumnList[] = new int[1];
        int highlightColumnlowerBorder[] = new int[1];
        int highlightColumnupperBorder[] = new int[1];
        
        if(optionNumber == 0)
        {
            highlightColumnList = new int[header.length -1];
            highlightColumnlowerBorder = new int[header.length -1];
            highlightColumnupperBorder = new int[header.length -1];
            
            for(int i=0;i<header.length-1;i++)
            {
                highlightColumnList[i] = i+1;
                highlightColumnlowerBorder[i] = (int)dataRangeMax[i];
                highlightColumnupperBorder[i] = (int)dataRangeMax[i];
            }
        }
        else if(optionNumber == 1)
        {
            highlightColumnList = new int[header.length -1];
            highlightColumnlowerBorder = new int[header.length -1];
            highlightColumnupperBorder = new int[header.length -1];
            
            for(int i=0;i<header.length-1;i++)
            {
                highlightColumnList[i] = i+1;
                highlightColumnlowerBorder[i] = (int)dataRangeMin[i];
                highlightColumnupperBorder[i] = (int)dataRangeMin[i];
            }
        }
        else if(optionNumber == 2)
        {
            highlightColumnList = new int[header.length -1];
            highlightColumnlowerBorder = new int[header.length -1];
            highlightColumnupperBorder = new int[header.length -1];
            
            for(int i=0;i<header.length-1;i++)
            {
                highlightColumnList[i] = i+1;
                highlightColumnlowerBorder[i] = (int)dataRangeMin[i]+1;
                highlightColumnupperBorder[i] = (int)dataRangeMax[i]-1;
            }
        }
        else if(optionNumber == 3)
        {
            highlightColumnList = new int[header.length -1];
            highlightColumnlowerBorder = new int[header.length -1];
            highlightColumnupperBorder = new int[header.length -1];
            
            int border;
            
            for(int i=0;i<header.length-1;i++)
            {
                border = findMinID(frequencyData[i]);
                highlightColumnList[i] = i+1;
                highlightColumnlowerBorder[i] = border;
                highlightColumnupperBorder[i] = border;
            }
        }
        else if(optionNumber == 4)
        {
            
            highlightColumnList = new int[header.length -1];
            highlightColumnlowerBorder = new int[header.length -1];
            highlightColumnupperBorder = new int[header.length -1];
            
            int border;

            for(int i=0;i<header.length-1;i++)
            {
                border = findMaxID(frequencyData[i]);
                highlightColumnList[i] = i+1;
                highlightColumnlowerBorder[i] = border;
                highlightColumnupperBorder[i] = border;
            }
            
            
             //   highlightColumnList[0] = 3;
               // highlightColumnlowerBorder[0] = 4;
               // highlightColumnupperBorder[0] = 4;
        }
        
        
        
        
        
        
        
        
        
        
        setDataIntegerArray(0,highlightColumnList);
        setDataIntegerArray(1,highlightColumnlowerBorder);
        setDataIntegerArray(2,highlightColumnupperBorder);
        
        displayOperations(25);
    }
    
}

